<?php

namespace Teknisa\MAN\Services;

use Doctrine\ORM\EntityManager;
use Teknisa\MAN\Utilities;

class GerenciamentoComandaService {

	public function __construct(EntityManager $entityManager) {
        $this->entityManager = $entityManager;
        
    }
    
    public function insereComandasAut($comandas) {
        $this->entityManager->getConnection()->beginTransaction();
        try{
            foreach ($comandas as $comanda) {
            	$params = array(
                	":CDFILIAL" => $comanda['CDFILIAL'],
			     	":CDLOJA" => $comanda['CDLOJA'],
			     	":DSCOMANDAFOS" => $comanda['DSCOMANDAFOS'],
			     	":DSOBSCOMANDAFOS" => $comanda['DSOBSCOMANDAFOS'],
			     	":IDSITCOMANDAFOS" => $comanda['IDSITCOMANDAFOS'],
			     	":DTSITCOMANDAFOS" => $comanda['DTSITCOMANDAFOS'],
			     	":CDOPERADOR" => $comanda['CDOPERADOR'],
			     	":CDCLIENTE" => $comanda['CDCLIENTE'],
			     	":CDCONSUMIDOR" => $comanda['CDCONSUMIDOR'],
			     	":CDCARTAOMIFARE" => $comanda['CDCARTAOMIFARE'],
			     	":NRORG" => $comanda['NRORG'],
			     	":DTULTATUCOMANDA" => $comanda['DTULTATUCOMANDA'],
			     	":DTINCLUSAO" => $comanda['DTINCLUSAO'],
			     	":DTULTATU" => $comanda['DTULTATU'],
			     	":IDATIVO" => $comanda['IDATIVO']
                );
            
                $this->entityManager->getConnection()->executeQuery(self::INSERT_CADAUTO, $params);
            }
            $this->entityManager->getConnection()->commit();
        }catch(Exception $e){
            
            $this->entityManager->getConnection()->rollBack();
            $response->addMessage(new Message("Erro ao cadastrar."));
            $response->setError(new Error($e->getMessage(), $e->getCode()));
        }
    }
    
    public function comandasCadastradas($params){
		return $this->entityManager->getConnection()->fetchAll(self::SELECT_COMANDAS, $params);
	}
	
    public function altComandasAut($comandas) {
        $this->entityManager->getConnection()->beginTransaction();
        try{
            foreach ($comandas as $comanda) {
            	$params = array(
                	":CDFILIAL" => $comanda['CDFILIAL'],
			     	":CDLOJA" => $comanda['CDLOJA'],
			     	":DSCOMANDAFOS" => $comanda['DSCOMANDAFOS'],
			     	":DSOBSCOMANDAFOS" => $comanda['DSOBSCOMANDAFOS'],
			     	":IDSITCOMANDAFOS" => $comanda['IDSITCOMANDAFOS'],
			     	":DTSITCOMANDAFOS" => $comanda['DTSITCOMANDAFOS'],
			     	":CDOPERADOR" => $comanda['CDOPERADOR'],
			     	":CDCLIENTE" => $comanda['CDCLIENTE'],
			     	":CDCONSUMIDOR" => $comanda['CDCONSUMIDOR'],
			     	":CDCARTAOMIFARE" => $comanda['CDCARTAOMIFARE'],
			     	":NRORG" => $comanda['NRORG'],
			     	":DTULTATUCOMANDA" => $comanda['DTULTATUCOMANDA'],
			     	":DTULTATU" => $comanda['DTULTATU']
                );
            
                $this->entityManager->getConnection()->executeQuery(self::ALT_CADAUTO, $params);
            }
            $this->entityManager->getConnection()->commit();
        }catch(Exception $e){
            $this->entityManager->getConnection()->rollBack();
        }
    }
    
    
	public function deleteComandas($NRORG, $CDFILIAL, $CDLOJA, $DSCOMANDAFOS, $CDOPERADOR) {
	      $params = array(
         	":CDFILIAL" =>	$CDFILIAL,
         	":CDLOJA" =>	$CDLOJA,
         	":DSCOMANDAFOS" =>	$DSCOMANDAFOS,
         	":CDOPERADOR" =>	$CDOPERADOR,
         	":NRORG" =>	$NRORG
     		);
     		$response = $this->entityManager->getConnection()->executeQuery(self::DELETE_INVOICES, $params);
	    return $response;
	}
	
    const DELETE_INVOICES = "
    	DELETE FROM COMANDAFOS
    	 WHERE CDFILIAL 	   = :CDFILIAL
    	   AND CDLOJA   	   = :CDLOJA
    	   AND DSCOMANDAFOS	   = :DSCOMANDAFOS
    	   AND NRORG		   = :NRORG
    ";
    
    const INSERT_CADAUTO = "
        INSERT INTO COMANDAFOS
            (CDFILIAL, CDLOJA, DSCOMANDAFOS, DSOBSCOMANDAFOS, IDSITCOMANDAFOS, DTSITCOMANDAFOS,  CDOPERADOR, CDCLIENTE, CDCONSUMIDOR, CDCARTAOMIFARE, NRORG, DTULTATUCOMANDA, DTINCLUSAO, DTULTATU, IDATIVO)
                VALUES
            (:CDFILIAL, :CDLOJA, :DSCOMANDAFOS, :DSOBSCOMANDAFOS, :IDSITCOMANDAFOS, :DTSITCOMANDAFOS,  :CDOPERADOR, :CDCLIENTE, :CDCONSUMIDOR, :CDCARTAOMIFARE, :NRORG, :DTULTATUCOMANDA, :DTINCLUSAO, :DTULTATU, :IDATIVO)
    ";
    
    const SELECT_COMANDAS = "
            SELECT C.DSCOMANDAFOS, C.DSOBSCOMANDAFOS, C.IDSITCOMANDAFOS, C.DTSITCOMANDAFOS, C.CDOPERADOR, C.CDCLIENTE, C.CDCONSUMIDOR, C.CDCARTAOMIFARE 
                FROM COMANDAFOS C 
                WHERE C.CDFILIAL = :CDFILIAL AND C.CDLOJA = :CDLOJA AND C.NRORG = :NRORG";
    
    const ALT_CADAUTO ="
        UPDATE COMANDAFOS SET
            DSOBSCOMANDAFOS = :DSOBSCOMANDAFOS, IDSITCOMANDAFOS = :IDSITCOMANDAFOS, DTSITCOMANDAFOS = :DTSITCOMANDAFOS, CDOPERADOR = :CDOPERADOR, CDCLIENTE = :CDCLIENTE, CDCONSUMIDOR = :CDCONSUMIDOR, CDCARTAOMIFARE = :CDCARTAOMIFARE
            WHERE CDFILIAL = :CDFILIAL
              AND CDLOJA   = :CDLOJA
              AND DSCOMANDAFOS = :DSCOMANDAFOS
              AND NRORG = :NRORG
    ";
    
}